package cn.com.infosec.asn1.cms;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1OctetString;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DEREncodable;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERTaggedObject;

public class OriginatorIdentifierOrKey extends ASN1Encodable {
   private DEREncodable id;

   public OriginatorIdentifierOrKey(IssuerAndSerialNumber id) {
      this.id = id;
   }

   public OriginatorIdentifierOrKey(ASN1OctetString id) {
      OriginatorIdentifierOrKey var10000 = this;
      super();
      DERTaggedObject var2;
      var2 = new DERTaggedObject.<init>(false, 0, id);
      var10000.id = var2;
   }

   public OriginatorIdentifierOrKey(OriginatorPublicKey id) {
      OriginatorIdentifierOrKey var10000 = this;
      super();
      DERTaggedObject var2;
      var2 = new DERTaggedObject.<init>(false, 1, id);
      var10000.id = var2;
   }

   public OriginatorIdentifierOrKey(DERObject id) {
      this.id = id;
   }

   public static OriginatorIdentifierOrKey getInstance(ASN1TaggedObject o, boolean explicit) {
      if (explicit) {
         return getInstance(o.getObject());
      } else {
         throw new IllegalArgumentException("Can't implicitly tag OriginatorIdentifierOrKey");
      }
   }

   public static OriginatorIdentifierOrKey getInstance(Object o) {
      if (o != null && !(o instanceof OriginatorIdentifierOrKey)) {
         if (o instanceof DERObject) {
            return new OriginatorIdentifierOrKey((DERObject)o);
         } else {
            throw new IllegalArgumentException("Invalid OriginatorIdentifierOrKey: " + o.getClass().getName());
         }
      } else {
         return (OriginatorIdentifierOrKey)o;
      }
   }

   public DEREncodable getId() {
      return this.id;
   }

   public OriginatorPublicKey getOriginatorKey() {
      DEREncodable var1;
      return (var1 = this.id) instanceof ASN1TaggedObject && ((ASN1TaggedObject)var1).getTagNo() == 1 ? OriginatorPublicKey.getInstance((ASN1TaggedObject)this.id, false) : null;
   }

   public DERObject toASN1Object() {
      return this.id.getDERObject();
   }
}
